import { expect } from 'chai'
import hre from 'hardhat'
import { Contract, Signer, BigNumber } from 'ethers'
import { time } from '@nomicfoundation/hardhat-network-helpers'

const { deployContract } = hre.ethers

const ZERO_ADDRESS = '0x0000000000000000000000000000000000000000'

describe('OneSidedStaking', () => {
  const wallets = hre.ethers.getSigners()

  let wallet0: Signer
  let wallet1: Signer
  let wallet2: Signer
  let wallet3: Signer
  let token: Contract
  let staking: Contract
  let start_ts: number
  let ACC_PRECISION: number
  beforeEach('deploy tokens', async () => {
    [wallet0, wallet1, wallet2, wallet3] = await wallets
    token = await deployContract("MockERC20", ['Staking token', 'STK', 0])
    staking = await deployContract("OneSidedStaking", [token.address, token.address])
    start_ts = await time.latest()
    await staking.adminChangeReward(1)
    await staking.adminUnpause()
    await token.mint(await wallet1.getAddress(), '1000000000000000000000')
    await token.connect(wallet1).approve(staking.address, '1000000000000000000000')
    await token.mint(await wallet2.getAddress(), '1000000000000000000000')
    await token.connect(wallet2).approve(staking.address, '1000000000000000000000')
    await token.mint(await wallet3.getAddress(), '1000000000000000000000')
    await token.connect(wallet3).approve(staking.address, '1000000000000000000000')
    ACC_PRECISION = await staking.ACC_PRECISION()
  })

  describe('#staking', () => {
    it('user can stake and unstake their tokens', async () => {
      const balance1 = await token.balanceOf(await wallet1.getAddress())
      const balance2 = await token.balanceOf(await wallet1.getAddress())
      const balance3 = await token.balanceOf(await wallet1.getAddress())
      expect(await staking.pendingRewards(await wallet1.getAddress())).to.eq(0)
      await staking.connect(wallet1).stake(1000)
      expect(await token.balanceOf(await wallet1.getAddress())).to.eq(balance1.sub(1000))
      const preReward = await staking.accReward() / ACC_PRECISION
      
      let ts = await time.latest()
      const {rewardDebt, virtualAmount} = await staking.depositInfo(await wallet1.getAddress())
      expect(rewardDebt).to.eq(await staking.accReward())
      expect(virtualAmount).to.eq(1000)
      expect(await staking.totalStaked()).to.eq(1000)
      expect(await staking.pendingRewards(await wallet1.getAddress())).to.eq(0)

      await staking.connect(wallet2).stake(2000)
      expect(await token.balanceOf(await wallet2.getAddress())).to.eq(balance2.sub(2000))
      let ts1 = await time.latest()
      const oldRewards = ts1 - ts
      const {rewardDebt: rewardDebt2, virtualAmount: virtualAmount2} = await staking.depositInfo(await wallet2.getAddress())
      expect(rewardDebt2).to.eq((await staking.accReward()).mul(2000).div(ACC_PRECISION))
      expect(virtualAmount2).to.eq(2000)
      expect(await staking.totalStaked()).to.eq(3000)
      expect(await staking.pendingRewards(await wallet1.getAddress())).to.eq(1) // ~1 second passed to execute transactions
      
      await time.increase(1000)
      await staking.updateRewards()
      ts = await time.latest()
      const newRewards = ts - ts1
      expect(await staking.accReward()).to.eq(BigNumber.from(oldRewards - preReward).mul(ACC_PRECISION).div(1000).add(BigNumber.from(newRewards).mul(ACC_PRECISION).div(3000)))
      expect(await staking.pendingRewards(await wallet1.getAddress())).to.eq(1 + Math.trunc(newRewards * 1000 / 3000))
      expect(await staking.pendingRewards(await wallet2.getAddress())).to.eq(Math.trunc(newRewards * 2000 / 3000))

      await staking.connect(wallet3).stake(1000)
      expect(await token.balanceOf(await wallet3.getAddress())).to.eq(balance1.sub(1000))
      await time.increase(999) // we leave 1 second luft for natural passing of time trough other transactions
      await staking.updateRewards()
      expect(await staking.pendingRewards(await wallet1.getAddress())).to.eq(1 + Math.trunc(newRewards * 1000 / 3000) + Math.trunc(1000 * 1000 / 4000))
      expect(await staking.pendingRewards(await wallet2.getAddress())).to.eq(Math.trunc(newRewards * 2000 / 3000) + Math.trunc(1000 * 2000 / 4000))
      expect(await staking.pendingRewards(await wallet3.getAddress())).to.eq(Math.trunc(1000 * 1000 / 4000))

      await staking.connect(wallet1).unstake(1000)
      const {amount, lockedUntil} = await staking.unstakingRequests(await wallet1.getAddress(), 0)
      expect(amount).to.eq(1000)
      expect(lockedUntil).to.eq(await time.latest() + (32 * 86400))
      // delay for unstaking
      await time.increase(32 * 86400)
      await staking.connect(wallet1).claimAllUnstaked()
      await expect(staking.connect(wallet1).claimAllUnstaked())
        .to.revertedWithCustomError(staking, 'InvalidAmount')

      expect(await token.balanceOf(await wallet1.getAddress())).to.eq(balance1)
      // we assume +1 reward for roundings because of truncation
      expect(await staking.pendingRewards(await wallet1.getAddress())).to.eq(1 + Math.trunc(newRewards * 1000 / 3000) + Math.trunc(1000 * 1000 / 4000) + 1)
      expect(await staking.pendingRewards(await wallet2.getAddress())).to.eq(Math.trunc(newRewards * 2000 / 3000) + Math.trunc(1000 * 2000 / 4000) + 2 + Math.trunc(32 * 86400 * 2000 / 3000))
      expect(await staking.pendingRewards(await wallet3.getAddress())).to.eq(Math.trunc(1000 * 1000 / 4000) + 1 + Math.trunc(32 * 86400 * 1000 / 3000))

      await time.increase(1000)
      const reward1 = 1 + Math.trunc(newRewards * 1000 / 3000) + Math.trunc(1000 * 1000 / 4000) + 1
      const reward2 = Math.trunc(newRewards * 2000 / 3000) + Math.trunc(1000 * 2000 / 4000) + 2 + Math.trunc(32 * 86400 * 2000 / 3000) + 1 + Math.trunc(1000 * 2000 / 3000)
      const reward3 = Math.trunc(1000 * 1000 / 4000) + 1 + Math.trunc(32 * 86400 * 1000 / 3000) + 1 + Math.trunc(1000 * 1000 / 3000)
      expect(await staking.pendingRewards(await wallet1.getAddress())).to.eq(reward1)
      expect(await staking.pendingRewards(await wallet2.getAddress())).to.eq(reward2)
      expect(await staking.pendingRewards(await wallet3.getAddress())).to.eq(reward3)
      await token.mint(staking.address, '1000000000000000000000')
      await staking.connect(wallet1).claim()
      expect(await staking.pendingRewards(await wallet1.getAddress())).to.eq(0)
      await staking.connect(wallet2).claim()
      expect(await staking.pendingRewards(await wallet2.getAddress())).to.eq(0)
      await staking.connect(wallet3).claim()
      expect(await staking.pendingRewards(await wallet3.getAddress())).to.eq(0)
      expect(await token.balanceOf(await wallet1.getAddress())).to.eq(balance1.add(reward1))
      expect(await token.balanceOf(await wallet2.getAddress())).to.eq(balance2.sub(2000).add(reward2).add(2)) // +2 new rewards occured
      expect(await token.balanceOf(await wallet3.getAddress())).to.eq(balance3.sub(1000).add(reward3).add(1)) // +1 new reward occured
    })

    it('users can increase / descrease their stackes, reward rate can be updated as well', async () => {
      await staking.connect(wallet1).stake(555)
      await staking.connect(wallet2).stake(1100)
      await time.increase(1000)
      expect(await staking.pendingRewards(await wallet1.getAddress())).to.eq(336)
      expect(await staking.pendingRewards(await wallet2.getAddress())).to.eq(665)
      await staking.connect(wallet1).stake(555)
      await time.increase(1000)
      expect(await staking.pendingRewards(await wallet1.getAddress())).to.eq(336 + 502)
      expect(await staking.pendingRewards(await wallet2.getAddress())).to.eq(665 + 499)
      await staking.connect(wallet2).stake(565)

      await staking.connect(wallet2).unstake(500)
      var {amount, lockedUntil} = await staking.unstakingRequests(await wallet2.getAddress(), 0)
      expect(amount).to.eq(500)
      expect(lockedUntil).to.eq(await time.latest() + (32 * 86400))
      await time.increase(1)
      await staking.connect(wallet2).unstake(55)
      var {amount, lockedUntil} = await staking.unstakingRequests(await wallet2.getAddress(), 1)
      expect(amount).to.eq(55)
      expect(lockedUntil).to.eq(await time.latest() + (32 * 86400))
      // delay for unstaking
      await time.increase(32 * 86400)
      expect(await staking.pendingRewards(await wallet1.getAddress())).to.eq(336 + 502 + 2 + (32 * 86400 / 2))
      expect(await staking.pendingRewards(await wallet2.getAddress())).to.eq(665 + 499 + 1 + (32 * 86400 / 2))
      
      await time.increase(1000)
      expect(await staking.pendingRewards(await wallet1.getAddress())).to.eq(336 + 502 + 2 + (32 * 86400 / 2) + 500)
      expect(await staking.pendingRewards(await wallet2.getAddress())).to.eq(665 + 499 + 1 + (32 * 86400 / 2) + 500)
      expect(await staking.totalStaked()).to.eq(2220)
      expect((await staking.depositInfo(await wallet1.getAddress())).virtualAmount).to.eq(1110)
      expect((await staking.depositInfo(await wallet2.getAddress())).virtualAmount).to.eq(1110)
      await staking.adminChangeReward(2)
      await time.increase(1000)
      expect(await staking.pendingRewards(await wallet1.getAddress())).to.eq(336 + 502 + 3 + (32 * 86400 / 2) + 500 + 1000)
      expect(await staking.pendingRewards(await wallet2.getAddress())).to.eq(665 + 499 + 2 + (32 * 86400 / 2) + 500 + 1000)
      await staking.connect(wallet2).claimAllUnstaked()
      expect(await token.balanceOf(staking.address)).to.eq(await staking.totalStaked())
      var {amount, lockedUntil} = await staking.unstakingRequests(await wallet2.getAddress(), 0)
      expect(amount).to.eq(0)
      expect(lockedUntil).to.eq(0)
      var {amount, lockedUntil} = await staking.unstakingRequests(await wallet2.getAddress(), 1)
      expect(amount).to.eq(0)
      expect(lockedUntil).to.eq(0)
    })

    it('unstaking in batches and with tickets', async () => {
      await staking.connect(wallet1).stake(1000)
      const balance1 = await token.balanceOf(await wallet1.getAddress())
      await staking.connect(wallet1).unstake(10)
      await time.increase(1000)
      await staking.connect(wallet1).unstake(50)
      await time.increase(1000)
      await staking.connect(wallet1).unstake(100)
      await time.increase(1000)
      await staking.connect(wallet1).unstake(200)
      await time.increase(1000)
      await staking.connect(wallet1).unstake(60)
      await time.increase(1000)
      await staking.connect(wallet1).unstake(30)
      await expect(staking.connect(wallet1).claimAllUnstaked())
        .to.revertedWithCustomError(staking, 'InvalidAmount')

      // delay for unstaking
      await time.increase(32 * 86400 - 5000)
      expect(await staking.pendingUnstaking()).to.eq(450)
      await staking.connect(wallet1).claimAllUnstaked()
      expect(await token.balanceOf(await wallet1.getAddress())).to.eq(balance1.add(10))
      expect(await staking.pendingUnstaking()).to.eq(440)
      await time.increase(3000)
      await staking.connect(wallet1).claimAllUnstaked()
      expect(await token.balanceOf(await wallet1.getAddress())).to.eq(balance1.add(360))
      expect(await staking.pendingUnstaking()).to.eq(90)
      await staking.connect(wallet1).unstake(100)
      await time.increase(2000)
      await expect(staking.connect(wallet1).claimUnstaked(0))
        .to.revertedWithCustomError(staking, 'InvalidAmount')
      await staking.connect(wallet1).claimUnstaked(4)
      await expect(staking.connect(wallet1).claimUnstaked(4))
        .to.revertedWithCustomError(staking, 'InvalidAmount')
      expect(await token.balanceOf(await wallet1.getAddress())).to.eq(balance1.add(420))
      expect(await staking.pendingUnstaking()).to.eq(130)
      await staking.connect(wallet1).claimAllUnstaked()
      expect(await token.balanceOf(await wallet1.getAddress())).to.eq(balance1.add(450))
      expect(await staking.pendingUnstaking()).to.eq(100)

      var {amount, lockedUntil} = await staking.unstakingRequests(await wallet1.getAddress(), 6)
      expect(amount).to.eq(100)
      expect(lockedUntil).to.eq(await time.latest() + 32 * 86400 - 2004)
      await expect(staking.connect(wallet1).claimUnstaked(6))
        .to.revertedWithCustomError(staking, 'LockedTokens')
      await time.increase(32 * 86400)
      await staking.connect(wallet1).claimAllUnstaked()
      expect(await token.balanceOf(await wallet1.getAddress())).to.eq(balance1.add(550))
      expect(await staking.pendingUnstaking()).to.eq(0)
      await expect(staking.connect(wallet1).claimUnstaked(6))
        .to.revertedWithCustomError(staking, 'InvalidAmount')
    })

    it('users cant claim unstaked early', async () => {
      await staking.connect(wallet1).stake(1000)
      await time.increase(1000)
      expect(await staking.pendingRewards(await wallet1.getAddress())).to.eq(1000)
      await staking.connect(wallet1).unstake(1)
      await time.increase(1000)
      await expect(staking.connect(wallet1).claimAllUnstaked())
        .to.revertedWithCustomError(staking, 'InvalidAmount')
    })

    it('users cant stake and claim when paused, but can unstake', async () => {
      await staking.connect(wallet1).stake(1000)
      const balance1 = await token.balanceOf(await wallet1.getAddress())
      await time.increase(32 * 86400)
      await staking.adminPause();
      expect(await staking.pendingRewards(await wallet1.getAddress())).to.eq(32 * 86400 + 1)
      await expect(staking.connect(wallet1).stake(1000))
        .to.revertedWith('Pausable: paused')
      await expect(staking.connect(wallet1).claim())
        .to.revertedWith('Pausable: paused')
      await expect(staking.connect(wallet2).unstake(100))
        .to.revertedWithCustomError(staking, 'NotEnoughTokens')
      await token.mint(staking.address, '100')
      await staking.connect(wallet1).unstake(100)
      // delay for unstaking
      await time.increase(32 * 86400)
      await staking.connect(wallet1).claimAllUnstaked()
      expect((await staking.depositInfo(await wallet1.getAddress())).virtualAmount).to.eq(900)
      expect(await token.balanceOf(await wallet1.getAddress())).to.eq(balance1.add(100))
    })

    it('only admin can pause, unpause and change reward rate', async () => {
      await expect(staking.connect(wallet1).adminPause())
        .to.revertedWith('Ownable: caller is not the owner')
      await expect(staking.connect(wallet1).adminUnpause())
        .to.revertedWith('Ownable: caller is not the owner')
      await expect(staking.connect(wallet1).adminChangeReward(2))
        .to.revertedWith('Ownable: caller is not the owner')
      await expect(staking.connect(wallet1).adminChangeLockup(0))
        .to.revertedWith('Ownable: caller is not the owner')

      await staking.adminPause()
      expect(await staking.paused()).to.eq(true)
      await staking.adminUnpause()
      expect(await staking.paused()).to.eq(false)
      await staking.adminChangeReward(2)
      expect(await staking.rewardPerSecond()).to.eq(2)
      await expect(staking.adminChangeReward('1000000000000000000'))
        .to.revertedWithCustomError(staking, 'InvalidRewardRate')
      await staking.adminChangeLockup(0)
      expect(await staking.defaultLockup()).to.eq(0)
      await expect(staking.adminChangeLockup(31537000))
        .to.revertedWithCustomError(staking, 'InvalidLockup')
    })

    it('only possible to use non-zero staking and unstaking', async () => {
      await token.mint(staking.address, 1000)
      await expect(staking.connect(wallet1).stake(0))
        .to.revertedWithCustomError(staking, 'InvalidAmount')
      await expect(staking.connect(wallet1).claim())
        .to.revertedWithCustomError(staking, 'NoReward')
      await staking.connect(wallet1).stake(1)
      await expect(staking.connect(wallet1).unstake(0))
        .to.revertedWithCustomError(staking, 'InvalidAmount')
      await expect(staking.connect(wallet1).claimAllUnstaked())
        .to.revertedWithCustomError(staking, 'InvalidAmount')
    })

    it('there is no overflow if 1b supply (100% of token) is staked for the whole period of LP program of 2 years', async () => {
      await staking.adminChangeReward('800000000000000000')
      const balance1 = await token.balanceOf(await wallet1.getAddress())
      await token.mint(await wallet1.getAddress(), '1000000000000000000000000000')
      await token.connect(wallet1).approve(staking.address, '1000000000000000000000000000')
      await staking.connect(wallet1).stake('1000000000000000000000000000')
      await time.increase(32 * 86400 * 24) // total time of liquidity program
      expect(await staking.pendingRewards(await wallet1.getAddress())).to.eq(BigNumber.from(32 * 86400 * 24).mul('800000000000000000'))
      await staking.connect(wallet1).claim()
      expect(await token.balanceOf(await wallet1.getAddress())).to.eq(balance1.add(BigNumber.from(32 * 86400 * 24 + 1).mul('800000000000000000')))
    })

    it('possible to take and repay a loan by admin if there are enough tokens', async () => {
      await token.mint(staking.address, '1')
      await expect(staking.connect(wallet1).adminBorrow(1))
        .to.revertedWithCustomError(staking, 'Unauthorized')
      await expect(staking.adminBorrow(100))
        .to.revertedWithCustomError(staking, 'NotEnoughTokens')
      await staking.connect(wallet1).stake(100)
      await staking.adminBorrow(100)
      expect(await token.balanceOf(await wallet0.getAddress())).to.eq(100)
      expect(await staking.trustedDebts(await wallet0.getAddress())).to.eq(100)
      await staking.connect(wallet1).stake(50)
      await staking.adminBorrow(25)
      expect(await token.balanceOf(await wallet0.getAddress())).to.eq(125)
      expect(await staking.trustedDebts(await wallet0.getAddress())).to.eq(125)
      expect(await token.balanceOf(staking.address)).to.eq(25 + 1)

      await expect(staking.returnDebt(await wallet0.getAddress(), 100))
        .to.revertedWith('ERC20: insufficient allowance')
      await token.approve(staking.address, 100)
      await staking.returnDebt(await wallet0.getAddress(), 100)
      expect(await token.balanceOf(await wallet0.getAddress())).to.eq(25)
      expect(await staking.trustedDebts(await wallet0.getAddress())).to.eq(25)
      expect(await token.balanceOf(staking.address)).to.eq(125 + 1)

      await expect(staking.connect(wallet1).returnDebt(await wallet0.getAddress(), 50))
        .to.revertedWithCustomError(staking, 'InvalidAmount')
      await expect(staking.connect(wallet1).returnDebt(await wallet0.getAddress(), 0))
        .to.revertedWithCustomError(staking, 'InvalidAmount')
      await staking.connect(wallet1).returnDebt(await wallet0.getAddress(), 25)
      expect(await token.balanceOf(await wallet0.getAddress())).to.eq(25)
      expect(await staking.trustedDebts(await wallet0.getAddress())).to.eq(0)
      expect(await token.balanceOf(staking.address)).to.eq(150 + 1)
    })

    it('possible to take and repay a loan by uathorized party if there are enough tokens and authorization', async () => {
      const balance1 = await token.balanceOf(await wallet1.getAddress())
      await token.mint(staking.address, '1')
      await expect(staking.connect(wallet1).adminBorrow(1))
        .to.revertedWithCustomError(staking, 'Unauthorized')
      await staking.connect(wallet2).stake(100)
      await staking.adminAuthorizeCreditLine(await wallet1.getAddress(), 100)
      await expect(staking.connect(wallet1).adminBorrow(0))
        .to.revertedWithCustomError(staking, 'InvalidAmount')
      await staking.connect(wallet2).unstake(2)
      await expect(staking.connect(wallet1).adminBorrow(100))
        .to.revertedWithCustomError(staking, 'NotEnoughTokens')
      await staking.connect(wallet2).stake(1)
      await staking.connect(wallet1).adminBorrow(100)
      expect(await token.balanceOf(await wallet1.getAddress())).to.eq(balance1.add(100))
      expect(await staking.trustedDebts(await wallet1.getAddress())).to.eq(100)
      await staking.connect(wallet2).stake(50)
      await expect(staking.connect(wallet1).adminBorrow(25))
        .to.revertedWithCustomError(staking, 'Unauthorized')
      await staking.adminAuthorizeCreditLine(await wallet1.getAddress(), 25)
      await expect(staking.connect(wallet1).adminBorrow(25))
        .to.revertedWithCustomError(staking, 'Unauthorized')
      await staking.adminAuthorizeCreditLine(await wallet1.getAddress(), 150)
      await staking.connect(wallet1).adminBorrow(25)
      await staking.connect(wallet1).returnDebt(await wallet1.getAddress(), 50)
      await staking.connect(wallet1).adminBorrow(50)
      expect(await token.balanceOf(await wallet1.getAddress())).to.eq(balance1.add(125))
      expect(await staking.trustedDebts(await wallet1.getAddress())).to.eq(125)
      expect(await token.balanceOf(staking.address)).to.eq(25 + 2)
      await staking.adminAuthorizeCreditLine(await wallet1.getAddress(), 0)
      await expect(staking.connect(wallet1).adminBorrow(25))
        .to.revertedWithCustomError(staking, 'Unauthorized')

      await token.approve(staking.address, 125)
      await expect(staking.returnDebt(await wallet1.getAddress(), 1))
        .to.revertedWithCustomError(staking, 'NotEnoughTokens')
      await token.mint(await wallet0.getAddress(), 125)
      await staking.returnDebt(await wallet1.getAddress(), 125)
      expect(await token.balanceOf(await wallet1.getAddress())).to.eq(balance1.add(125))
      expect(await staking.trustedDebts(await wallet1.getAddress())).to.eq(0)
      expect(await token.balanceOf(staking.address)).to.eq(150 + 2)
    })
  })
})